PG_DUMPALL(1)

NAME
pg_dumpall - Extract all databases into a script file

SYNOPSIS

pg_dumpall [ -c | --clean ] [ -h host ] [ -p port ] [ -g | --globals-only ]

DESCRIPTION

pg_dumpall is a utility for writing out (``dumping'') all Postgres databases of a cluster into one script file. The script file contains SQL commands that can be used as input to psql(1) to restore the databases. It does this by calling pg_dump(1) for each database in a cluster. pg_dumpall also dumps global objects that are common to all databases. (pg_dump does not save these objects.) This currently includes the information about database users and groups.

Thus, pg_dumpall is an integrated solution for backing up your databases.

Since pg_dumpall reads tables from all databases you will most likely have to connect as a database superuser in order to produce a complete dump. Also you will need superuser privileges to execute the saved script in order to be allowed to add users and groups, and to create databases.

The SQL script will be written to the standard ouput. Shell operators should be used to redirect it into a file.

  OPTIONS

pg_dumpall accepts the following command line arguments:

-c, --clean
    Clean (drop) database before creating schema.

-h host
    Specifies the hostname of the machine on which the database server is running. If host begins with a slash, it is used as the directory for the Unix domain socket. The default is taken from the PGHOST environment variable, if set, else a Unix domain socket connection is attempted.

-p port
    The port number on which the server is listening. Defaults to the PGPORT environment variable, if set, or a compiled-in default.

-g, --globals-only
    Only dump global objects (users and groups), no databases.

Any other command line parameters are passed to the underlying pg_dump(1) calls. This is useful to control some aspects of the output format, but some options such as -f, -t, and dbname should be avoided.

USAGE

To dump all databases:

$ pg_dumpall > db.out

To reload this database use, for example:

$ psql -f db.out template1

(It is not important to which database you connect here since the script file created by pg_dumpall will contain the appropriate commands to create and connect to the saved databases.)

SEE ALSO

pg_dump(1), psql(1). Check there for details on possible error conditions.